방법1 - 각 cell에서 1인 부분을 큐에 넣고 bfs를 통해 0까지의 최소 거리를 찾는다.

import java.util.*;
class Solution {
	public static int dr[] = { 0, 0, 1, -1 };
	public static int dc[] = { 1, -1, 0, 0 };

	public int[][] updateMatrix(int[][] matrix) {
		Queue<Position> queue = new LinkedList<Position>();
		for (int i = 0; i < matrix.length; i++) {
			for (int j = 0; j < matrix[i].length; j++) {
				if (matrix[i][j] != 0) {
					queue.add(new Position(i, j, 0));
				}
			}
		}

		while (!queue.isEmpty()) {
			Position now = queue.poll();
			updateCell(now.row, now.col, matrix);
		}
		return matrix;
	}

	public void updateCell(int row, int col, int[][] matrix) {
		Queue<Position> queue = new LinkedList<Position>();
		queue.add(new Position(row, col, 0));

		while (!queue.isEmpty()) {
			Position now = queue.poll();

			if (matrix[now.row][now.col] == 0) {
				matrix[row][col] = now.value;
				return;
			}

			for (int i = 0; i < 4; i++) {
				int newRow = now.row + dr[i];
				int newCol = now.col + dc[i];

				if (isBoundary(newRow, newCol, matrix)) {
					queue.add(new Position(newRow, newCol, now.value + 1));
				}
			}
		}
	}

	public boolean isBoundary(int row, int col, int[][] matrix) {
		if (row < 0 || row >= matrix.length) {
			return false;
		}
		if (col < 0 || col >= matrix[row].length) {
			return false;
		}
		return true;
	}

	public void printMatrix(int[][] matrix) {
		for (int i = 0; i < matrix.length; i++) {
			for (int j = 0; j < matrix[i].length; j++) {
				System.out.print(matrix[i][j] + " ");
			}
			System.out.println();
		}
	}
}

class Position {
	int row, col, value;

	public Position(int row, int col, int value) {
		this.row = row;
		this.col = col;
		this.value = value;
	}
}

 

방법2 - 어차피 matrix에 거리를 계속 업데이트 하고 있는데 이 것을 이용해서 다음 값을 구할 수 없을까? => DP

class Solution {
	public int[][] updateMatrix(int[][] matrix) {
		int n = matrix.length;
		int m = matrix[0].length;
		int[][] dp = matrix;
		int INF = 10000;

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (matrix[i][j] == 1) {
					dp[i][j] = INF;
				}
			}
		}

		for (int i = 1; i < n; i++) {
			dp[i][0] = Math.min(dp[i][0], dp[i - 1][0] + 1);
		}
		for (int i = 1; i < m; i++) {
			dp[0][i] = Math.min(dp[0][i], dp[0][i - 1] + 1);
		}

		for (int i = 1; i < n; i++) {
			for (int j = 1; j < m; j++) {
				dp[i][j] = Math.min(dp[i][j], Math.min(dp[i][j - 1], dp[i - 1][j]) + 1);
			}
		}

		for (int i = n - 2; i >= 0; i--) {
			dp[i][m - 1] = Math.min(dp[i + 1][m - 1] + 1, dp[i][m - 1]);
		}
		for (int i = m - 2; i >= 0; i--) {
			dp[n - 1][i] = Math.min(dp[n - 1][i + 1] + 1, dp[n - 1][i]);
		}

		for (int i = n - 2; i >= 0; i--) {
			for (int j = m - 2; j >= 0; j--) {
				dp[i][j] = Math.min(dp[i][j], Math.min(dp[i][j + 1], dp[i + 1][j]) + 1);
			}
		}

		return dp;
	}
}

'알고리즘 공부 > leetcode' 카테고리의 다른 글

leetcode: Maximum Frequency Stack  (0) 2021.01.23
leetcode: Range Sum Query - Mutable  (0) 2021.01.10
leetcode: Number of Islands  (0) 2021.01.07
leetcode: Trapping Rain Water  (0) 2020.12.27
leetcode: Median of two sorted Arrays  (0) 2020.12.26

전형적인 bfs문제이다. 

시간복잡도는 O(grid 요소의 갯수)와 같다.

import java.util.*;
class Solution {
	public static int dr[] = { 0, 1, 0, -1 };
	public static int dc[] = { 1, 0, -1, 0 };

	public int numIslands(char[][] grid) {
		int answer = 0;

		for (int i = 0; i < grid.length; i++) {
			for (int j = 0; j < grid[i].length; j++) {
				if (grid[i][j] == '1') {
					answer++;
					grid[i][j] = '0';
					bfs(i, j, grid);
				}
			}
		}
		return answer;
	}

	public static void bfs(int row, int col, char[][] grid) {
		Queue<Position> queue = new LinkedList<Position>();
		queue.add(new Position(row, col));

		while (!queue.isEmpty()) {
			Position now = queue.poll();

			for (int i = 0; i < 4; i++) {
				int newRow = now.row + dr[i];
				int newCol = now.col + dc[i];

				if (isBoundary(newRow, newCol, grid) && grid[newRow][newCol] == '1') {
					grid[newRow][newCol] = '0';
                    queue.add(new Position(newRow, newCol));
				}
			}
		}
	}

	public static boolean isBoundary(int row, int col, char[][] grid) {
		if (row < 0) {
			return false;
		}
		if (row >= grid.length) {
			return false;
		}
		if (col < 0) {
			return false;
		}
		if (col >= grid[row].length) {
			return false;
		}

		return true;
	}
}

class Position {
	int row, col;

	public Position(int row, int col) {
		this.row = row;
		this.col = col;
	}
}

1. 가장 높은 위치를 찾아서 큐에 넣는다

2. 큐에 넣은 위치를 시작점으로 하는 dfs를 돌려 등산로 길이 중 max값을 찾도록 한다.

   - dfs를 돌릴때에는 공사를 하는 경우/ 안하는 경우를 나눈다.

   - 공사를 하는 경우에는 최소 값만 깎도록 해야 선택 폭이 넓어짐

import java.util.*;
class Solution {
	public static int dr[] = { 0, 1, 0, -1 };
	public static int dc[] = { 1, 0, -1, 0 };
	public static int maxAnswer;

	public static void main(String args[]) {
		Scanner in = new Scanner(System.in);
		int test = in.nextInt();
		for (int t = 1; t <= test; t++) {
			int n = in.nextInt();
			int depth = in.nextInt();
			int[][] mat = new int[n][n];
			int max = 0;
			maxAnswer = 0;

			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					mat[i][j] = in.nextInt();
					max = Math.max(max, mat[i][j]);
				}
			}

			Queue<Position> queue = new LinkedList<Position>();
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (mat[i][j] == max) {
						queue.add(new Position(i, j));
					}
				}
			}

			while (!queue.isEmpty()) {
				boolean[][] isVisited = new boolean[n][n];

				Position now = queue.poll();

				isVisited[now.row][now.col] = true;
				dfs(now.row, now.col, depth, 1, 0, mat, isVisited, n);
			}
			System.out.println("#" + t + " " + maxAnswer);
		}

	}

	public static void dfs(int row, int col, int depth, int length, int minus, int[][] mat, boolean[][] isVisited,
			int n) {
		for (int i = 0; i < 4; i++) {
			maxAnswer = Math.max(maxAnswer, length);

			int newRow = row + dr[i];
			int newCol = col + dc[i];

			if (isBoundary(newRow, newCol, n) && !isVisited[newRow][newCol]) {
				// 깎는경우
				if (mat[row][col] <= mat[newRow][newCol] && mat[row][col] > mat[newRow][newCol] - depth) {
					isVisited[newRow][newCol] = true;
					dfs(newRow, newCol, 0, length + 1, mat[newRow][newCol] - mat[row][col] + 1, mat, isVisited, n);
					isVisited[newRow][newCol] = false;
				}
				// 안깎는경우
				else if (mat[row][col] - minus > mat[newRow][newCol]) {
					isVisited[newRow][newCol] = true;
					dfs(newRow, newCol, depth, length + 1, 0, mat, isVisited, n);
					isVisited[newRow][newCol] = false;
				}
			}
		}
	}

	public static boolean isBoundary(int row, int col, int N) {
		if (row < 0) {
			return false;
		}
		if (col < 0) {
			return false;
		}
		if (row >= N) {
			return false;
		}
		if (col >= N) {
			return false;
		}
		return true;
	}
}

class Position {
	int row;
	int col;

	public Position(int row, int col) {
		this.row = row;
		this.col = col;
	}
}

'알고리즘 공부' 카테고리의 다른 글

SWEA 1248: 공통조상  (0) 2021.01.17
SWEA 3462: 선표의 축구 경기 예측  (0) 2021.01.10
SWEA 1267: 작업순서  (0) 2021.01.03
SWEA 5653: 줄기세포 배양  (0) 2021.01.03
SWEA 5521: 상원이의 생일파티  (0) 2020.12.27

N x N 크기의 정사각형 격자 형태에서 (0, 0) ~ (N-1, N-1)까지 경주로를 만드는데

직선 도로 하나를 만들 때는 100원이 소요되며, 코너를 하나 만들 때는 500원이 든다.

경주로를 만드는 데 최소 비용을 구하는 문제이다.

 

1차 시도 - BFS로 모든 방향에 대한 비용을 구하면서 재방문의 경우는 제외해주도록 한다. -> O(3^N)이 걸릴 것이기 때문에 시간 초과..

심지어 정확도도 틀림

import java.util.*;
class Solution {
	public static int dr[] = { 0, 1, 0, -1 };
	public static int dc[] = { 1, 0, -1, 0 };

	public int solution(int[][] board) {
		Queue<Move> queue = new LinkedList<Move>();
		for (int i = 0; i < 4; i++) {
			queue.add(new Move(dr[i], dc[i], i, 100)); // 이 부분이 벽일 수도 있기 때문에 정확도가 틀린 것이었다.
		}

		int min = Integer.MAX_VALUE;
		int length = board.length;

		while (!queue.isEmpty()) {
			Move now = queue.poll();

			if (now.row == length - 1 && now.col == length - 1) {
				min = Math.min(min, now.value);
			}

			for (int i = 0; i < 4; i++) {
				if (Math.abs(i - now.direction) == 2) {
					continue;
				}

				int newRow = now.row + dr[i];
				int newCol = now.col + dc[i];
				int newValue = now.direction == i ? 100 : 600;
				newValue += now.value;

				if (isBoundary(newRow, newCol, length) && newValue > 0 && newValue < min
						&& board[newRow][newCol] == 0) {
					queue.add(new Move(newRow, newCol, i, newValue));
				}
			}

		}

		return min;
	}

	public boolean isBoundary(int row, int col, int N) {
		if (row < 0) {
			return false;
		}
		if (col < 0) {
			return false;
		}
		if (row >= N) {
			return false;
		}
		if (col >= N) {
			return false;
		}
		return true;
	}
}

class Move {
	int row;
	int col;
	int direction;
	int value;

	public Move(int row, int col, int direction, int value) {
		this.row = row;
		this.col = col;
		this.direction = direction;
		this.value = value;
	}
}

채점 결과

정확성: 30.4

합계: 30.4 / 100.0

 

 

 

2차시도 - 재 방문을 줄이자 => DP를 사용해볼까? 그런데 방향마다 더해지는 값이 달라서 DP에도 다르게 저장해야함

DP[i][j][k]: (0, 0) ~ (i, j)까지 k방향으로 움직였을 때 최소비용이라고 정의하도록 하자

import java.util.*;
import java.util.*;

class Solution {
	public static int dr[] = { 0, 1, 0, -1 };
	public static int dc[] = { 1, 0, -1, 0 };

	public int solution(int[][] board) {

		int min = Integer.MAX_VALUE;
		int length = board.length;

		int dp[][][] = new int[length][length][4];

		Queue<Move> queue = new LinkedList<Move>();
		for (int i = 0; i < 4; i++) {
			queue.add(new Move(0, 0, i, 0));
		}

		while (!queue.isEmpty()) {
			Move now = queue.poll();

			if (now.row == length - 1 && now.col == length - 1) {
				min = Math.min(min, dp[now.row][now.col][now.direction]);
			}

			for (int i = 0; i < 4; i++) {
				if (Math.abs(i - now.direction) != 2) { // 후진 제외
					int newRow = now.row + dr[i];
					int newCol = now.col + dc[i];
					int newValue = (now.direction == i ? 100 : 600) + now.value;

					if (isBoundary(newRow, newCol, length) && board[newRow][newCol] == 0) {
						if (dp[newRow][newCol][i] >= newValue || dp[newRow][newCol][i] == 0) {
							dp[newRow][newCol][i] = newValue;
							queue.add(new Move(newRow, newCol, i, newValue));
						}
					}
				}
			}
		}

		return min;
	}

	public boolean isBoundary(int row, int col, int N) {
		if (row < 0) {
			return false;
		}
		if (col < 0) {
			return false;
		}
		if (row >= N) {
			return false;
		}
		if (col >= N) {
			return false;
		}
		return true;
	}
}

class Move {
	int row;
	int col;
	int direction;
	int value;

	public Move(int row, int col, int direction, int value) {
		this.row = row;
		this.col = col;
		this.direction = direction;
		this.value = value;
	}
}

 

 

 

 

 

최고의 집합에 해당하는 조건은 아래와 같다.

  1. 각 원소의 합이 S가 되는 자연수의 집합
  2. 위 조건을 만족하면서 각 원소의 곱 이 최대가 되는 집합
  3. 자연수는 중복 가능

1차 시도 - 최대한 유사한 값들을 곱하면 최대가 될 것이다.

동일한 값으로 먼저 나누고, 나머지를 +1씩 해 주도록 한다.

class Solution {
	public int[] solution(int n, int s) {
		LinkedList<Integer> answer = new LinkedList<Integer>();

		if (s / n == 0) {
			answer.add(-1);
		} else {
			answer.addAll(findSimilarElements(n, s));
		}

		return answer.stream().sorted().mapToInt(i -> i).toArray();
	}

	public LinkedList<Integer> findSimilarElements(int n, int s) {
		LinkedList<Integer> list = new LinkedList<Integer>();
		int quotient = s / n;
		int remainder = s % n;

		for (int i = 0; i < remainder; i++) {
			list.add(quotient + 1);
		}
		for (int i = remainder; i < n; i++) {
			list.add(quotient);
		}

		return list;
	}
}

결과 - 시간초과

 

2차 시도 - sorting 부분을 지우자

1 <= n <= 10,000 이고 1 <= s <= 100,000,000이며 위의 경우는 sorting때문에 시간 복잡도가 O(NlogN)이었을 것이다.

아래와 같은 코드로 바꾼다면 O(N)만에 동작할 수 있다.

class Solution {
	public int[] solution(int n, int s) {
		LinkedList<Integer> answer = new LinkedList<Integer>();

		if (s / n == 0) {
			answer.add(-1);
		} else {
			answer.addAll(findSimilarElements(n, s));
		}

		return answer.stream().mapToInt(i -> i).toArray();
	}

	public LinkedList<Integer> findSimilarElements(int n, int s) {
		LinkedList<Integer> list = new LinkedList<Integer>();
		int quotient = s / n;
		int remainder = s % n;

		int quotientNumber = n - remainder;

		for (int i = 0; i < quotientNumber; i++) {
			list.add(quotient);
		}
		for (int i = quotientNumber; i < n; i++) {
			list.add(quotient + 1);
		}

		return list;
	}
}

결과는 마찬가지로 시간초과...

 

3차시도 - 아무래도 stream부분과 list를 addAll하는 곳 때문에 시간 초과가 난 것 같다.

어차피 원소의 개수는 n개로 일정하기 때문에 LinkedList를 array로 바꾸는 방식이 아니라 바로 array를 구하도록 하자

class Solution {
	public int[] solution(int n, int s) {
		if (s / n == 0) {
			return new int[] { -1 };
		}

		return findSimilarElements(n, s);
	}

	public int[] findSimilarElements(int n, int s) {
		int[] answer = new int[n];
		int quotient = s / n;
		int remainder = s % n;

		int quotientNumber = n - remainder;

		for (int i = 0; i < quotientNumber; i++) {
			answer[i] = quotient;
		}
		for (int i = quotientNumber; i < n; i++) {
			answer[i] = quotient + 1;
		}

		return answer;
	}
}

최단경로를 구하는 것이므로 길을 가는 방법은 오른쪽 또는 아래로 이동하는 방법밖에 없다.

즉, 현재 위치의 가짓수는 현재 위치의 위 또는 왼쪽에서 가능한 가짓수를 더한 값이다. => DP

 

이를 식으로 표현해 보면 DP[i][j] = DP[i-1][j] + DP[i][j-1]이다.

import java.util.*;
class Solution {
	public long solution(int m, int n, int[][] puddles) {
		long mat[][] = new long[n + 1][m + 1];
		for (int i = 1; i < mat.length; i++) {
			Arrays.fill(mat[i], -100);
			mat[i][0] = 0;
		}

		for (int i = 0; i < puddles.length; i++) {
			mat[puddles[i][1]][puddles[i][0]] = -1;
		}

		mat[1][1] = 1;

		findAll(n, m, mat);
		//printMat(mat);

		return mat[n][m];
	}

	public long findAll(int row, int col, long[][] mat) {
		if (mat[row][col] != -100) {
			return mat[row][col];
		}
		long left = findAll(row, col - 1, mat);
		long upper = findAll(row - 1, col, mat);

		if (left == -1 && upper == -1) {
			mat[row][col] = 0;
			return mat[row][col];
		}
		if (left == -1) {
			mat[row][col] = upper;
			return mat[row][col];
		}
		if (upper == -1) {
			mat[row][col] = left;
			return mat[row][col];
		}

		mat[row][col] = (left + upper) % 1000000007;
		return mat[row][col];
	}

	public static void printMat(long[][] mat) {
		for (int i = 0; i < mat.length; i++) {
			for (int j = 0; j < mat[i].length; j++) {
				System.out.print(mat[i][j] + " ");
			}
			System.out.println();
		}
	}
}

'알고리즘 공부 > programmers' 카테고리의 다른 글

Programmers 67259: 경주로 건설  (0) 2021.01.05
Programmers 12938: 최고의 집합  (0) 2021.01.05
Programmers 17685: 자동완성  (0) 2020.12.30
Programmers 43236: 징검다리  (0) 2020.12.26
Programmers 12907: 거스름돈  (0) 2020.12.24

위상 정렬 O(V + E)

  • 순서가 정해져 있는 작업을 차례대로 수행해야 할 때 그 순서를 결정해 주기 위한 알고리즘
  • 위상 정렬은 사이클이 없는 그래프에서만 사용 가능하다.
  • 스택 또는 큐를 이용해서 구현할 수 있다.

 

위상정렬의 구현 방법

  1. 진입차수(부모 노드의 수)가 0인 정점을 큐에 넣는다
  2. 큐에서 노드를 꺼내고, 이 노드에 연결된 모든 간선을 끊는다.
  3. 간선 제거 이후 진입차수가 0이 된 정점을 넣는다.
  4. 큐가 빌 때까지 2~3 반복

https://gmlwjd9405.github.io/2018/08/27/algorithm-topological-sort.html

 

import java.util.*;
class Solution {
public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int test = 10;
        for (int t = 1; t <= test; t++) {
            int v = in.nextInt(); // 정점
            int e = in.nextInt(); // 간선
 
            LinkedList<Integer> childs[] = new LinkedList[v + 1];
            for (int i = 0; i <= v; i++) {
                childs[i] = new LinkedList<Integer>();
            }
 
            int[] parentNum = new int[v + 1];
            boolean[] isVisited = new boolean[v + 1];
            for (int i = 0; i < e; i++) {
                int parentNode = in.nextInt();
                int childNode = in.nextInt();
 
                childs[parentNode].add(childNode);
                parentNum[childNode]++;
            }
 
            Queue<Integer> queue = new LinkedList<Integer>();
            for (int i = 1; i <= v; i++) {
                if (parentNum[i] == 0) {
                    queue.add(i);
                }
            }
 
            StringBuilder sb = new StringBuilder("#" + t + " ");
            while (!queue.isEmpty()) {
                int now = queue.poll();
                isVisited[now] = true;
                sb = sb.append(now + " ");
 
                LinkedList<Integer> links = childs[now];
                for (int node : links) {
                    parentNum[node]--;
                    if (!isVisited[node] && parentNum[node] == 0) {
                        queue.add(node);
                    }
                }
                links.clear();
            }
 
            System.out.println(sb);
        }
    }
}

'알고리즘 공부' 카테고리의 다른 글

SWEA 3462: 선표의 축구 경기 예측  (0) 2021.01.10
SWEA 1949: 등산로 조성  (0) 2021.01.07
SWEA 5653: 줄기세포 배양  (0) 2021.01.03
SWEA 5521: 상원이의 생일파티  (0) 2020.12.27
SWEA: 5215 햄버거 다이어트  (0) 2020.12.15
import java.util.*;

class Solution {
	static int n, m, k;
	static int[][] arr;
	static List<Pair> list;

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int test = in.nextInt();
		list = new ArrayList<>();
		for (int i = 1; i <= test; i++) {
			list.clear();

			n = in.nextInt();
			m = in.nextInt();
			k = in.nextInt();
			arr = new int[n + k][m + k];
			for (int j = (k / 2); j < (k / 2) + n; j++) {
				for (int z = (k / 2); z < (k / 2) + m; z++) {
					arr[j][z] = in.nextInt();
					if (arr[j][z] != 0)
						list.add(new Pair(j, z, arr[j][z], arr[j][z], k, 0));
				}
			}
			solve();
			
			int result = 0;
			for (int j = 0; j < arr.length; j++) {
				for (int z = 0; z < arr[0].length; z++) {
					if (arr[j][z] != 0 && arr[j][z] != -1)
						result++;
				}
			}
			System.out.println("#" + i + " " + result + "\n");
		}
	}

	static int[][] dir = { { 1, 0 }, { 0, 1 }, { -1, 0 }, { 0, -1 } };

	private static void solve() {
		PriorityQueue<Pair> queue = new PriorityQueue<Pair>(list);

		while (!queue.isEmpty()) {
			Pair t = queue.poll();
			if (t.state == 0 && t.flag == 1) {
				arr[t.x][t.y] = -1;
				continue;
			}
			if (t.time == 0) {
				continue;
			}
			if (t.state == 0) {
				queue.add(new Pair(t.x, t.y, t.k, t.k, t.time, 1));
			} else {
				queue.add(new Pair(t.x, t.y, t.k, t.state - 1, t.time - 1, t.flag));
				continue;
			}
			for (int i = 0; i < 4; i++) {
				int tx = t.x + dir[i][0];
				int ty = t.y + dir[i][1];
				if (tx < 0 || ty < 0 || tx >= n + k || ty >= m + k) {
					continue;
				}
				if (arr[tx][ty] != 0) {
					continue;
				}
				arr[tx][ty] = t.k;
				queue.add(new Pair(tx, ty, t.k, t.k, t.time - 1, 0));
			}
		}
	}
}

class Pair implements Comparable<Pair> {
	public int x;
	public int y;
	public int k;
	public int state; // 변하는 생명력
	public int time;
	public int flag; // 0이 되었을 때, 번식 했나 유무

	public Pair(int x, int y, int k, int state, int time, int flag) {
		this.x = x;
		this.y = y;
		this.k = k;
		this.state = state;
		this.time = time;
		this.flag = flag;
	}

	@Override
	public int compareTo(Pair o) {
		if (this.time > o.time) {
			return -1;
		} else if (this.time == o.time) {
			if (this.k > o.k) {
				return -1;
			}
			return 1;
		}
		return 1;
	}
}

'알고리즘 공부' 카테고리의 다른 글

SWEA 3462: 선표의 축구 경기 예측  (0) 2021.01.10
SWEA 1949: 등산로 조성  (0) 2021.01.07
SWEA 1267: 작업순서  (0) 2021.01.03
SWEA 5521: 상원이의 생일파티  (0) 2020.12.27
SWEA: 5215 햄버거 다이어트  (0) 2020.12.15

+ Recent posts